<?php

namespace app\admin\controller\mall;

use Throwable;
use app\common\controller\Backend;

/**
 * 积分订单
 */
class PintsOrder extends Backend
{
    /**
     * MallPintsOrder模型对象
     * @var object|null
     * @phpstan-var \app\common\model\MallPintsOrder|null
     */
    protected ?object $model = null;

    protected array|string $preExcludeFields = ['id', 'create_time', 'update_time'];

    protected array $withJoinTable = ['playxUserAsset'];

    protected string|array $quickSearchField = ['id'];

    public function initialize(): void
    {
        parent::initialize();
        $this->model = new \app\common\model\MallPintsOrder();
    }

    /**
     * 查看
     * @throws Throwable
     */
    public function index(\Webman\Http\Request $request): \support\Response
    {
        $response = $this->initializeBackend($request);
        if ($response !== null) {
            return $response;
        }

        if ($request->get('select') || $request->post('select')) {
            $this->_select();
            return $this->success();
        }

        list($where, $alias, $limit, $order) = $this->queryBuilder();
        $res = $this->model
            ->with(['playxUserAsset' => function ($query) {
                $query->field('id,username');
            }])
            ->visible(['playxUserAsset' => ['username']])
            ->alias($alias)
            ->where($where)
            ->order($order)
            ->paginate($limit);

        return $this->success('', [
            'list'   => $res->items(),
            'total'  => $res->total(),
            'remark' => get_route_remark(),
        ]);
    }

    /**
     * 若需重写查看、编辑、删除等方法，请复制 @see \app\admin\library\traits\Backend 中对应的方法至此进行重写
     */
}